package com.ningdatech.carapi.common.constant;

import io.swagger.annotations.ApiModel;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import org.apache.commons.lang3.StringUtils;

import java.util.ArrayList;
import java.util.List;

/**
 * 告警类型
 *
 * @author PoffyZhang
 */
@Getter
@AllArgsConstructor
@NoArgsConstructor
@ApiModel(value = "AlarmTypeEnum", description = "告警类型-枚举")
public enum AlarmTypeEnum {
    /**
     * 視頻遮擋
     */
    ADAS_ALARM_20102("视频遮挡", "0x00020102"),
    ADAS_ALARM_20502("前向碰撞", "0x00020502"),
    ADAS_ALARM_20504("车道偏离（左）", "0x00020504"),
    ADAS_ALARM_20506("车道偏离（右）", "0x00020506"),
    ADAS_ALARM_20508("车距过近", "0x00020508"),
    ADAS_ALARM_20510("行人防撞", "0x00020510"),
    ADAS_ALARM_20511("不礼让行人", "0x00020511"),
    ADAS_ALARM_37005("路口快速通过", "0x00037005"),
    ADAS_ALARM_20512("疲劳驾驶预警", "0x00020512"),
    ADAS_ALARM_20513("疲劳驾驶", "0x00020513"),
    ADAS_ALARM_20514("分神提醒预警", "0x00020514"),
    ADAS_ALARM_20515("分神提醒", "0x00020515"),
    ADAS_ALARM_20516("接打电话", "0x00020516"),
    ADAS_ALARM_20517("抽烟", "0x00020517"),
    ADAS_ALARM_20519("驾驶员检测异常", "0x00020519"),
    ADAS_ALARM_2051A("驾驶员异常", "0x0002051A"),
    ADAS_ALARM_20523("急加速", "0x00020523"),
    ADAS_ALARM_20524("急减速", "0x00020524"),
    ADAS_ALARM_20525("急左转弯", "0x00020525"),
    ADAS_ALARM_20526("急右转弯", "0x00020526"),
    ADAS_ALARM_20534("驾驶员身份异常", "0x00020534"),
    ADAS_ALARM_20518("未系安全带", "0x00020518"),
    ADAS_ALARM_37001("墨镜红外阻断报警", "0x00037001"),
    ADAS_ALARM_37002("双手脱离方向盘报警", "0x00037002"),
    ADAS_ALARM_37006("单手脱离方向盘报警", "0x00037006"),
    ADAS_ALARM_37101("右转弯不停车", "0x00037101"),
    ADAS_ALARM_37100("右转弯超速", "0x00037100"),
    ADAS_ALARM_20559("紧急告警", "0x00020559"),
    ADAS_ALARM_20528("车辆碰撞", "0x00020528"),
    ADAS_ALARM_20530("车辆侧翻", "0x00020530"),
    ADAS_ALARM_20560("车辆被盗", "0x00020560"),
    ADAS_ALARM_20561("车辆非法点火", "0x00020561"),
    ADAS_ALARM_20562("车辆非法位移", "0x00020562"),
    NA("不支持的报警类型", "999");



    private String desc;
    private String code;

    public String getDesc() {
        return desc;
    }

    public void setDesc(String desc) {
        this.desc = desc;
    }

    public static String getDescByCode(String code) {
        if(StringUtils.isBlank(code)){
            return StringUtils.EMPTY;
        }
        for (AlarmTypeEnum t : AlarmTypeEnum.values()) {
            if (code.equals(t.getCode())) {
                return t.desc;
            }
        }
        return StringUtils.EMPTY;
    }

    public boolean eq(String val) {
        return this.name().equals(val);
    }

}
